<?php
class DETECT_ENC {
	
	private $logfile="wp-content/ayar_rss_log.txt";
	private $fh;
	private $BeginTime;
	private $EndTime;
	
	//unicode number to character
	private function unichr($hex)
	{
		$str="&#".hexdec($hex).";";
		return html_entity_decode($str, ENT_QUOTES, "UTF-8");
	}
	function detect_encoding($txt)
	{
	
		$j=0;		
				
		$pattern[$j]="/([ၐ-႟])/u";//u1050-\u109f
		
		$j++;
	
		$pattern[$j]="/ေ[ျၾ]/u";//\u1031\u103b

		$j++;
		
		
		$txt=preg_match($pattern, $txt);
		
		return $txt;
	}
	
	function html_decode($constr)
	{	
		//change HTML to unicode
		
		$en_chr=array("&#4096;", "&#4097;", "&#4098;", "&#4099;", "&#4100;", "&#4101;", "&#4102;", "&#4103;", "&#4104;", "&#4105;", "&#4106;", "&#4107;", "&#4108;", "&#4109;", "&#4110;", "&#4111;", "&#4112;", "&#4113;", "&#4114;", "&#4115;", "&#4116;", "&#4117;", "&#4118;", "&#4119;", "&#4120;", "&#4121;", "&#4122;", "&#4123;", "&#4124;", "&#4125;", "&#4126;", "&#4127;", "&#4128;", "&#4129;", "&#4130;", "&#4131;", "&#4132;", "&#4133;", "&#4134;", "&#4135;", "&#4136;", "&#4137;", "&#4138;", "&#4139;", "&#4140;", "&#4141;", "&#4142;", "&#4143;", "&#4144;", "&#4145;", "&#4146;", "&#4147;", "&#4148;", "&#4149;", "&#4150;", "&#4151;", "&#4152;", "&#4153;", "&#4154;", "&#4155;", "&#4156;", "&#4157;", "&#4158;", "&#4159;", "&#4160;", "&#4161;", "&#4162;", "&#4163;", "&#4164;", "&#4165;", "&#4166;", "&#4167;", "&#4168;", "&#4169;", "&#4170;", "&#4171;", "&#4172;", "&#4173;", "&#4174;", "&#4175;", "&#4176;", "&#4177;", "&#4178;", "&#4179;", "&#4180;", "&#4181;", "&#4182;", "&#4183;", "&#4184;", "&#4185;", "&#4186;", "&#4187;", "&#4188;", "&#4189;", "&#4190;", "&#4191;", "&#4192;", "&#4193;", "&#4194;", "&#4195;", "&#4196;", "&#4197;", "&#4198;", "&#4199;", "&#4200;", "&#4201;", "&#4202;", "&#4203;", "&#4204;", "&#4205;", "&#4206;", "&#4207;", "&#4208;", "&#4209;", "&#4210;", "&#4211;", "&#4212;", "&#4213;", "&#4214;", "&#4215;", "&#4216;", "&#4217;", "&#4218;", "&#4219;", "&#4220;", "&#4221;", "&#4222;", "&#4223;", "&#4224;", "&#4225;", "&#4226;", "&#4227;", "&#4228;", "&#4229;", "&#4230;", "&#4231;", "&#4232;", "&#4233;", "&#4234;", "&#4235;", "&#4236;", "&#4237;", "&#4238;", "&#4239;", "&#4240;", "&#4241;", "&#4242;", "&#4243;", "&#4244;", "&#4245;", "&#4246;", "&#4247;", "&#4248;", "&#4249;", "&#4250;", "&#4251;", "&#4252;", "&#4253;", "&#4254;", "&#4255;");
	
		$utf8_chr=array("က", "ခ", "ဂ", "ဃ", "င", "စ", "ဆ", "ဇ", "ဈ", "ဉ", "ည", "ဋ", "ဌ", "ဍ", "ဎ", "ဏ", "တ", "ထ", "ဒ", "ဓ", "န", "ပ", "ဖ", "ဗ", "ဘ", "မ", "ယ", "ရ", "လ", "ဝ", "သ", "ဟ", "ဠ", "အ", "ဢ", "ဣ", "ဤ", "ဥ", "ဦ", "ဧ", "ဨ", "ဩ", "ဪ", "ါ", "ာ", "ိ", "ီ", "ု", "ူ", "ေ", "ဲ", "ဳ", "ဴ", "ဵ", "ံ", "့", "း", "္", "်", "ျ", "ြ", "ွ", "ှ", "ဿ", "၀", "၁", "၂", "၃", "၄", "၅", "၆", "၇", "၈", "၉", "၊", "။", "၌", "၍", "၎", "၏", "ၐ", "ၑ", "ၒ", "ၓ", "ၔ", "ၕ", "ၖ", "ၗ", "ၘ", "ၙ", "ၚ", "ၛ", "ၜ", "ၝ", "ၞ", "ၟ", "ၠ", "ၡ", "ၢ", "ၣ", "ၤ", "ၥ", "ၦ", "ၧ", "ၨ", "ၩ", "ၪ", "ၫ", "ၬ", "ၭ", "ၮ", "ၯ", "ၰ", "ၱ", "ၲ", "ၳ", "ၴ", "ၵ", "ၶ", "ၷ", "ၸ", "ၹ", "ၺ", "ၻ", "ၼ", "ၽ", "ၾ", "ၿ", "ႀ", "ႁ", "ႂ", "ႃ", "ႄ", "ႅ", "ႆ", "ႇ", "ႈ", "ႉ", "ႊ", "ႋ", "ႌ", "ႍ", "ႎ", "ႏ", "႐", "႑", "႒", "႓", "႔", "႕", "႖", "႗", "႘", "႙", "ႚ", "ႛ", "ႜ", "ႝ", "႞", "႟");
		
		
		$last=str_replace($en_chr,$utf8_chr,$constr);
		return $last;
		
	}
	
	static function FormatElapsed($Start, $End = NULL) {
		  if($End === NULL)
			 $Elapsed = $Start;
		  else
			 $Elapsed = $End - $Start;
	
		  $m = floor($Elapsed / 60);
		  $s = $Elapsed - $m * 60;
		  $Result = sprintf('%02d:%05.2f', $m, $s);
	
		  return $Result;
	}
	
	/*
	Log Files
	*/
	function start_log()
	{
		//start time
		$this->fh = fopen($this->logfile, 'w') or die("can't open file");
		$this->BeginTime=microtime(true);
	}
	
	function decodedone_log()
	{
		fwrite($this->fh,"HTML Decode Done.\n");
	}
	
	function end_log()
	{
		//end time
		$this->EndTime=microtime(true);
		fwrite($this->fh,"Total Time:");
		fwrite($this->fh, self::FormatElapsed($this->EndTime-$this->BeginTime));
		fclose($this->fh);
	}
}

$detect_encoding = new DETECT_ENC();

$content = "ဖြဲ႔စည္းပံု အေျခခံဥပေဒခံုရံုးႏွင့္ပတ္သက္၍ ျပည္ေထာင္စုလႊတ္ေတာ္၌ ယေန႔ ေဆြးေႏြးခဲ့ေသာ ေဒၚေအာင္ဆန္းစုၾကည္(ေကာ့မွဴးမဲဆႏၵနယ္)၏ ေဆြးေႏြးခ်က္ အျပည့္အစံုမွာ ေအာက္ပါအတိုင္းျဖစ္သည္။အခု ဦးျမင့္စိုးအဆိုကို တရားဥပေဒရႈေထာင့္က ၾကည့္ႏိုင္သလို ႏိုင္ငံေရးရႈေထာင့္ကလည္း ၾကည့္ႏိုင္ပါတယ္။ တရားဥေဒရႈေထာင့္ကေန အမ်ားအျပား ေဆြးေႏြးသြားၿပီး ျဖစ္ပါတယ္။ အဲဒါကိုေတာ့ ထပ္ၿပီးမေဆြးေႏြးေတာ့ပါဘူး။ ႏိုင္ငံေရးရႈေထာင့္ကေနပဲ ေဆြးေႏြးပါရေစ။ ႏိုင္ငံေရးရႈေထာင့္ကေန ၾကည့္မယ္ဆိုရင္ ဒီမုိကေရစီကိုက်င့္သံုးတဲ့ ႏိုင္ငံေတြမွာ အုပ္ခ်ဳပ္ေရးမ႑ိဳင္၊ ဥပေဒျပဳမ႑ိဳင္၊ တရားစီရင္ေရးမ႑ိဳင္တို႔အၾကား ခ်ိန္ခြင္လွ်ာညီမွ်ေရးအတြက္ ေဆာင္ရြက္ၾကရတာ ျဖစ္ပါတယ္။ အဲဒီကိစၥနဲ႔ပတ္သက္ၿပီး အျငင္းအခံုေတြ ျဖစ္ၾကတာ ျပသနာေတြတက္တာ မထူးဆန္းပါဘူး။ ထိုနည္းတူပဲ ဖြဲ႔စည္းပံု အေျခခံဥပေဒနဲ႔ပတ္သက္ၿပီး အျငင္းပြားမႈေတြ ျဖစ္တာ။ သေဘာ မတူညီမႈေတြျဖစ္တာ၊ ျပသနာေတြတက္တာလည္း မထူးဆန္းပါဘူး။ ဒီလိုအေျခအေနေတြ ေရာက္ခဲ့ရင္ ႀကိဳက္သလို မႀကိဳက္သလို ဒီဘက္ဟိုဘက္ ေ၀ဖန္တာ တိုက္ခိုက္တာ ေျပာဆိုတာေတြ ရွိတတ္ပါတယ္။ ဒီလိုျပသနာေတြတက္လို႔ ကၽြန္မတို႔အေနနဲ႔လည္း စိတ္ပ်က္စရာလည္း မရွိပါဘူး။ ေၾကာက္ရြံ႕စရာလည္း မရွိပါဘူး။ ဘယ္ေလာက္ပဲ အေရးႀကီးတဲ့ ျပသနာေတြပဲျဖစ္ျဖစ္ တယ္အေရးႀကီးတာက ဒီျပသနာကို ဘယ္လိုေျဖရွင္းမလဲ ဆိုတာပါပဲ။ ျပသနာကို ေျဖရွင္းတဲ့ေနရာမွာ တကယ့္ ဒီမုိကေရစီစံႏႈန္းစံထားေတြနဲ႔ ညီရဲ႕လား။ တကယ္ကို ျပည္သူျပည္သားေတြရဲ႕ ေအးခ်မ္းသာယာေရးကို ဦးတည္ရဲ႕လားဆိုတာကို စဥ္းစားၿပီးေတာ့ ေျဖရွင္းရမွာ ျဖစ္ပါတယ္။ ျပသနာေျဖရွင္းပံု ေျဖရွင္းနည္းက မွန္လို႔ရွိရင္ ကၽြန္မတို႔ ႏိုင္ငံရဲ႕ သိကၡာလည္းတက္ပါလိမ့္မယ္။ ျပည္သူေတြကလည္း ဒီေျဖရွင္းပံုေျဖရွင္းနည္းရဲ႕ရလဒ္ကို တေလးတစားနဲ႔ လက္ခံမွာျဖစ္ပတယ္။ ဒါေၾကာင့္မို႔လို႔ ကၽြန္မေျပာခ်င္တာိက အခုကိစၥက တရားဥပေဒကိစၥျဖစ္တဲ့အပိုင္းမွာ တရားဥပေဒအရ ေက်ေက်နပ္နပ္ ႏွစ္ဦးႏွစ္ဖက္ ေဆြးေႏြးဖို႔လိုပါတယ္။ တစ္ဖက္နဲ႔တစ္ဖက္ ေလးစားဖို႔လိုပါတယ္။ ကိုယ့္အျမင္န႔ဲမတူတဲ့သူဟာ အားလံုးမွားတယ္ဆိုၿပီးေတာ့ စြပ္စြဲလို႔မရပါဘူး။ ကိုယ့္အျမင္ သူ႔အျမင္ ႏွစ္ဖက္စလုးကို ေလးစားဖို႔လိုပါတယ္။ နားလည္ေအာင္ လုပ္ဖို႔လိုပါတယ္။ ျပည္သူေတြလည္း နားလည္ေအာင္ လုပ္ဖို႔လိုပါတယ္။ အဓိကကေတာ့ ျပည္သူေတြပါပဲ။ ျပည္သူေတြအတြက္ဆိုတဲ့ ဒီျပည္ေထာင္စုလႊတ္ေတာ္ဟာ ျပည္သူေတြရဲ႕ ေလးစားမႈခံႏိုင္မွ ျပည္ေထာင္စုလႊတ္ေတာ္ဆိုတဲ့ ဂုဏ္နဲ႔ကိုက္ညီမွာ ျဖစ္ပါတယ္။ ဒါေၾကာင့္အခု ျပသနာတက္ေနတာ မွန္ပါတယ္။ ဒီျပသနာကို ေျဖရွင္းတဲ့ေနရာမွာ အားလံုးဟာ ညွိညွိႏိႈင္းႏိႈင္း တိုင္တိုင္ပင္ပင္ သေဘာထားႀကီးႀကီးနဲ႔ အေျမာအျမင္ရွိရွိနဲ႔ ေျဖရွင္းဖို႔ကိုပဲ ဦးတည္ၾကပါလို႔ ကၽြန္မအေနနဲ႔ ေမတၱာရပ္ခံရင္း နိဂုံးခ်ဳပ္ပါတယ္။";

$content = $detect_encoding->detect_encoding($content);
var_dump($content);

?>
